clang-tools 6.0.0

Public Types | Public Member Functions | List of all members
clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck Class Reference

Checks for classes where some, but not all, of the special member functions are defined. More...

`#include <SpecialMemberFunctionsCheck.h>`

Inheritance diagram for clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck:
[legend]
Collaboration diagram for clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck:
[legend]

## Public Types
enum | SpecialMemberFunctionKind : uint8_t { SpecialMemberFunctionKind::Destructor, SpecialMemberFunctionKind::DefaultDestructor, SpecialMemberFunctionKind::NonDefaultDestructor, SpecialMemberFunctionKind::CopyConstructor, SpecialMemberFunctionKind::CopyAssignment, SpecialMemberFunctionKind::MoveConstructor, SpecialMemberFunctionKind::MoveAssignment }
using | ClassDefId = std::pair< SourceLocation, std::string >
using | ClassDefiningSpecialMembersMap = llvm::DenseMap< ClassDefId, llvm::SmallVector< SpecialMemberFunctionKind, 5 > >

## Public Member Functions
| SpecialMemberFunctionsCheck (StringRef Name, ClangTidyContext *Context)
void | storeOptions (ClangTidyOptions::OptionMap &Opts) override
| Should store all options supported by this check with their current values or default values for options that haven't been overridden. More...
void | registerMatchers (ast_matchers::MatchFinder *Finder) override
| Override this to register AST matchers with `Finder`. More...
void | check (const ast_matchers::MatchFinder::MatchResult &Result) override
| `ClangTidyChecks` that register ASTMatchers should do the actual work in here. More...
void | onEndOfTranslationUnit () override
Public Member Functions inherited from clang::tidy::ClangTidyCheck
| ClangTidyCheck (StringRef CheckName, ClangTidyContext *Context)
| Initializes the check with `CheckName` and `Context`. More...
virtual void | registerPPCallbacks (CompilerInstance &Compiler)
| Override this to register `PPCallbacks` with `Compiler`. More...
DiagnosticBuilder | diag (SourceLocation Loc, StringRef Description, DiagnosticIDs::Level Level=DiagnosticIDs::Warning)
| Add a diagnostic with the check's name. More...

## Additional Inherited Members
Protected Member Functions inherited from clang::tidy::ClangTidyCheck
StringRef | getCurrentMainFile () const
| Returns the main file name of the current translation unit. More...
LangOptions | getLangOpts () const
| Returns the language options from the context. More...
Protected Attributes inherited from clang::tidy::ClangTidyCheck
OptionsView | Options

## Detailed Description

Checks for classes where some, but not all, of the special member functions are defined.

For the user-facing documentation see: http://clang.llvm.org/extra/clang-tidy/checks/cppcoreguidelines-special-member-functions.html

Definition at line 26 of file SpecialMemberFunctionsCheck.h.

## Member Typedef Documentation

## ◆ ClassDefId

using clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck::ClassDefId = std::pair<SourceLocation, std::string>

Definition at line 44 of file SpecialMemberFunctionsCheck.h.

## ◆ ClassDefiningSpecialMembersMap

using clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck::ClassDefiningSpecialMembersMap = llvm::DenseMap<ClassDefId, llvm::SmallVector<SpecialMemberFunctionKind, 5> >

Definition at line 48 of file SpecialMemberFunctionsCheck.h.

## Member Enumeration Documentation

## ◆ SpecialMemberFunctionKind

enum clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck::SpecialMemberFunctionKind : uint8_t
| strong

Enumerator
Destructor |
DefaultDestructor |
NonDefaultDestructor |
CopyConstructor |
CopyAssignment |
MoveConstructor |
MoveAssignment |

Definition at line 34 of file SpecialMemberFunctionsCheck.h.

## Constructor & Destructor Documentation

## ◆ SpecialMemberFunctionsCheck()

clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck::SpecialMemberFunctionsCheck | ( | StringRef | Name,
|  | ClangTidyContext * | Context
| ) |  |

Definition at line 25 of file SpecialMemberFunctionsCheck.cpp.

## Member Function Documentation

## ◆ check()

void clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck::check | ( | const ast_matchers::MatchFinder::MatchResult & | Result | ) |
| override virtual

`ClangTidyChecks` that register ASTMatchers should do the actual work in here.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 101 of file SpecialMemberFunctionsCheck.cpp.

References CopyAssignment, CopyConstructor, DefaultDestructor, Kind, MoveAssignment, MoveConstructor, and NonDefaultDestructor.

## ◆ onEndOfTranslationUnit()

void clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck::onEndOfTranslationUnit | ( |  | ) |
| override

Definition at line 134 of file SpecialMemberFunctionsCheck.cpp.

References CopyAssignment, CopyConstructor, DefaultDestructor, Destructor, clang::tidy::ClangTidyCheck::diag(), clang::tidy::ClangTidyCheck::getLangOpts(), clang::tidy::cppcoreguidelines::join(), Kind, MoveAssignment, MoveConstructor, and NonDefaultDestructor.

## ◆ registerMatchers()

void clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck::registerMatchers | ( | ast_matchers::MatchFinder * | Finder | ) |
| override virtual

Override this to register AST matchers with `Finder`.

This should be used by clang-tidy checks that analyze code properties that dependent on AST knowledge.

You can register as many matchers as necessary with `Finder`. Usually, "this" will be used as callback, but you can also specify other callback classes. Thereby, different matchers can trigger different callbacks.

If you need to merge information between the different matchers, you can store these as members of the derived class. However, note that all matches occur in the order of the AST traversal.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 37 of file SpecialMemberFunctionsCheck.cpp.

## ◆ storeOptions()

void clang::tidy::cppcoreguidelines::SpecialMemberFunctionsCheck::storeOptions | ( | ClangTidyOptions::OptionMap & | Options | ) |
| override virtual

Should store all options supported by this check with their current values or default values for options that haven't been overridden.

The check should use `Options.store()` to store each option it supports whether it has the default value or it has been overridden.

Reimplemented from clang::tidy::ClangTidyCheck.

Definition at line 31 of file SpecialMemberFunctionsCheck.cpp.

References clang::tidy::ClangTidyCheck::Options, and clang::tidy::OptionsView::store().

The documentation for this class was generated from the following files:

- SpecialMemberFunctionsCheck.h
- SpecialMemberFunctionsCheck.cpp